/*
 * This class implements java.sql.Clob. 
 * The class can be freely used, distributed and modified.
 *  i-net software 2002
 */


import java.sql.*;
import java.io.*;

public class StringClob implements java.sql.Clob
{
    private String s;
    
    public StringClob( String data ) throws SQLException {
        if( data == null )
            throw new SQLException( "[StringClob] invalid parameter: null" );
            
        s = data;   
    }
    
    public java.io.InputStream getAsciiStream() throws SQLException
    {
        return new ByteArrayInputStream( s.getBytes() );
    }

    public java.io.Reader getCharacterStream() throws SQLException
    {
        return new StringReader( s );
    }

    public String getSubString( long pos, int length ) throws SQLException
    {
        return s.substring( (int)pos - 1, (int)pos + length - 1 );
    }

    public long length() throws SQLException
    {
        return s.length();
    }

    public long position( String searchstr, long start ) throws SQLException
    {
        return s.indexOf( searchstr, (int)start - 1 );
    }

    public long position( Clob searchstr, long start ) throws SQLException
    {
        return position( searchstr.getSubString( 1, (int)searchstr.length() ), start );
    }
}
